'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _child_process = require('child_process');

var _shellQuote = require('shell-quote');

var _shellQuote2 = _interopRequireDefault(_shellQuote);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Customizable MeCab connector.
 */

let MeCab = function () {
  /**
   * @param {string} command a command string to be executed via spawn.
   */

  function MeCab(_ref) {
    var _ref$command = _ref.command;
    let command = _ref$command === undefined ? 'mecab' : _ref$command;

    _classCallCheck(this, MeCab);

    this._command = command;
  }

  _createClass(MeCab, [{
    key: '_getCommandStr',
    value: function _getCommandStr(text) {
      const echoCommand = _shellQuote2.default.quote(['echo', text]);
      return `${ echoCommand } | ${ this._command }`;
    }

    /**
     * Analyze a given text with MeCab.
     * @param {string} text a text string to be parsed.
     * @return {Promise<Array<Array<string>>}
     */

  }, {
    key: 'parse',
    value: function parse(text) {
      return new Promise((resolve, reject) => {
        (0, _child_process.exec)(this._getCommandStr(text), (err, result) => {
          /* istanbul ignore if */
          if (err) {
            return reject(err);
          }

          const parsed = result.split('\n').map(line => line.replace(/\t/g, ',').split(',')).filter(line => line.length >= 6);

          return resolve(parsed);
        });
      });
    }
  }]);

  return MeCab;
}();

exports.default = MeCab;
//# sourceMappingURL=mecab.js.map